<?php ob_start();
require_once 'lib/nusoap.php';
require_once 'config.php';
require_once 'telegram.php';
$telegram = new telegram(TOKEN,HOST,USERNAME,PASSWORD,DBNAME);

$TokenCode = BAHAMTAMD;

if(!isset($_GET['action'],$_GET['type'])) exit;


$action = $_GET['action'];
$type = $_GET['type'];
$callback_url = baseURI."bahamta.php?type=$type&action=verify";
$time = time();
if($type == 'renew'){
    if($action == 'pay'){
        $token = base64_decode($_GET['token']);
        $input = explode('#',$token); 
        $userid = intval($input[0]);
        $fid = intval($input[1]);
        $oid = intval($input[2]);

        $order = $telegram->db->query("select * from fl_order where id=$oid")->fetch(2);
        //$fid = $order['fileid'];
        $remark = $order['remark'];
        $server_id = $order['server_id'];
        $inbound_id = $order['inbound_id'];
        $respd = $telegram->db->query("select * from fl_file WHERE id='$fid' and active=1")->fetch(2);
        $name = $respd['title'];
        $days = $respd['days'];
        $volume = $respd['volume'];
        $price = $respd['price'];
        $seller = $telegram->db->query("select * from fl_sellers where userid=$userid")->fetch(2);
				if(!empty($seller)) $price = $price - (($price) * ($seller['percent'] / 100));
        
        if(isset($input[3])){
            $dcode = htmlspecialchars(strip_tags($input[3]));
            $dcount = $telegram->db->query("select * from fl_discount WHERE code='$dcode' and active=1");
        	if($dcount->rowCount() > 0){
        		$dres = $dcount->fetch(2);
        		$amount = $dres['amount'];
        		if($amount <= 100) {
        			$price = $price * (100-$amount)/100;
        		}else {
        			$price = $price - $amount ;
        		}
        		if($dres['count'] != '') $telegram->db->query("update fl_discount set count= count - 1 WHERE code='$dcode'");
        	}
        }
        
        $tkid = time();
        file_put_contents("state/$tkid-token-renew.txt", base64_encode($token));

        bahamta_payment($price, $TokenCode, $tkid, $callback_url);
    }elseif($action == 'verify'){
        
        if (!isset($_REQUEST['state']) && $_REQUEST['state'] != 'wait_for_confirm') die('error on verify');
        $reference = $_REQUEST['reference'];
        $token = file_get_contents("state/$reference-token-renew.txt");
        if(!$token) exit;
        
        
        $input = explode('#',base64_decode($token));
        $userid = intval($input[0]);
        $fid = intval($input[1]);
        $oid = intval($input[2]);
        $order = $telegram->db->query("select * from fl_order where id=$oid")->fetch(2);
        //$fid = $order['fileid'];
        $remark = $order['remark'];
        $server_id = $order['server_id'];
        $inbound_id = $order['inbound_id'];
        $expire_date = $order['expire_date'];
        $expire_date = ($expire_date > $time) ? $expire_date : $time;
        $respd = $telegram->db->query("select * from fl_file WHERE id='$fid' and active=1")->fetch(2);
        $name = $respd['title'];
        $days = $respd['days'];
        $volume = $respd['volume'];
        $price = $respd['price'];
        
        $seller = $telegram->db->query("select * from fl_sellers where userid=$userid")->fetch(2);
				if(!empty($seller)) $price = $price - (($price) * ($seller['percent'] / 100));
        
        if(isset($input[3])){
            $dcode = htmlspecialchars(strip_tags($input[3]));
            $dcount = $telegram->db->query("select * from fl_discount WHERE code='$dcode' and active=1");
        	if($dcount->rowCount() > 0){
        		$dres = $dcount->fetch(2);
        		$amount = $dres['amount'];
        		if($amount <= 100) {
        			$price = $price * (100-$amount)/100;
        		}else {
        			$price = $price - $amount ;
        		}
        		if($dres['count'] != '') $telegram->db->query("update fl_discount set count= count - 1 WHERE code='$dcode'");
        	}
        }
				
        

        $pay_result = bahamta_verify($price, $reference, $TokenCode);
        if($pay_result == 'success'){
            unlink("state/$reference-token-renew.txt");
    
            require_once('vray.php');
            if($inbound_id > 0)
                $response = update_client_traffic($server_id, $inbound_id, $remark, $volume, $days);
            else
                $response = update_inbound_traffic($server_id, $remark, $volume, $days);
            if($response->success){
                $telegram->db->query("update fl_order set expire_date= $expire_date + $days * 86400,notif=0 where id='$oid'"); 
                $telegram->db->query("INSERT INTO `fl_extra_order` VALUES (NULL, '$userid', '$server_id', '$inbound_id', '$remark', '$price', '$time');");
                 echo 'تراکنش با موفقیت انجام شد';
                $msg = "✅ سفارش شما با موفقیت ثبت شد";
                $telegram->sendMessage($userid, $msg);
                $sndmsg = "
تمدید سرویس $remark با باهمتا
قیمت : $price
آیدی کاربر : $userid
آیدی سرور : $server_id
تعداد روز  $days
تعداد گیگ $volume
";
                $telegram->sendMessage($sendchnl,$sndmsg);
                $telegram->sendMessage($userid, "✅سرویس $remark با موفقیت تمدید شد");exit;
        
            }else {
                die("مشکل فنی در ارتباط با سرور. لطفا به مدیریت اطلاع بدید");
            }
        }
        
        
    }
}

if($type == 'day'){
    if($action == 'pay'){
        $token = base64_decode($_GET['token']);
        $input = explode('#',$token); 
        $server_id = intval($input[0]);
        $inbound_id = intval($input[1]);
        $remark = htmlspecialchars(strip_tags($input[2]));
        $planid = intval($input[3]);
        $userid = intval($input[4]); 
        $res = $telegram->db->query("select * from extra_day where id=$planid")->fetch(2);  
        $price = $res['price'];
        $seller = $telegram->db->query("select * from fl_sellers where userid=$userid")->fetch(2);
				if(!empty($seller)) $price = $price - (($price) * ($seller['percent'] / 100));
        $volume = $res['volume'];
        
        $tkid = time();
        file_put_contents("state/$tkid-token-day.txt", base64_encode($token));
        
        bahamta_payment($price, $TokenCode, $tkid, $callback_url);
    }elseif($action == 'verify'){
        if (!isset($_REQUEST['state']) && $_REQUEST['state'] != 'wait_for_confirm') die('error on verify');
        $reference = $_REQUEST['reference'];
        $token = file_get_contents("state/$reference-token-day.txt");
        if(!$token) exit;
        
        $input = explode('#',base64_decode($token));
        $server_id = intval($input[0]);
        $inbound_id = intval($input[1]);
        $remark = htmlspecialchars(strip_tags($input[2]));
        $planid = intval($input[3]);
        $userid = intval($input[4]); 
        $res = $telegram->db->query("select * from extra_day where id=$planid")->fetch(2);  
        $volume = $res['volume'];
        $price = $res['price'];
        $seller = $telegram->db->query("select * from fl_sellers where userid=$userid")->fetch(2);
				if(!empty($seller)) $price = $price - (($price) * ($seller['percent'] / 100));
				
        $pay_result = bahamta_verify($price, $reference, $TokenCode);
        if($pay_result == 'success'){
            unlink("state/$reference-token-day.txt");
    
            require_once('vray.php');
            if($inbound_id > 0)
                $response = update_client_traffic($server_id, $inbound_id, $remark, 0, $volume);
            else
                $response = update_inbound_traffic($server_id, $remark, 0, $volume);
            if($response->success){
                $telegram->db->query("update fl_order set expire_date= expire_date + $volume * 86400,notif=0 where remark='$remark'");
                $telegram->db->query("INSERT INTO `fl_extra_order` VALUES (NULL, '$userid', '$server_id', '$inbound_id', '$remark', '$price', '$time');");
                $telegram->sendMessage($userid, "✅$volume روز به مدت زمان سرویس شما اضافه شد");
                echo 'تراکنش با موفقیت انجام شد';
                $msg = "✅ سفارش شما با موفقیت ثبت شد";
                $telegram->sendMessage($userid, $msg);
                $sndmsg = "
خرید $volume روز با درگاه باهمتا
قیمت : $price
آیدی کاربر : $userid
آیدی سرور : $server_id
ریمارک : $remark
";
    $telegram->sendMessage($sendchnl,$sndmsg);
        
            }else {
                die("مشکل فنی در ارتباط با سرور. لطفا به مدیریت اطلاع بدید");
            }
        }
        
        
    }
}

if($type == 'volume'){
    if($action == 'pay'){
        $token = base64_decode($_GET['token']);
        $input = explode('#',$token); 
        $server_id = intval($input[0]);
        $inbound_id = intval($input[1]);
        $remark = htmlspecialchars(strip_tags($input[2]));
        $planid = intval($input[3]);
        $userid = intval($input[4]); 
        $res = $telegram->db->query("select * from extra_plan where id=$planid")->fetch(2);  
        $price = $res['price'];
        $volume = $res['volume'];
         $seller = $telegram->db->query("select * from fl_sellers where userid=$userid")->fetch(2);
				if(!empty($seller)) $price = $price - (($price) * ($seller['percent'] / 100));
        
        $tkid = time();
        file_put_contents("state/$tkid-token-volume.txt", base64_encode($token));
        
        bahamta_payment($price, $TokenCode, $tkid, $callback_url);
    }elseif($action == 'verify'){
        if (!isset($_REQUEST['state']) && $_REQUEST['state'] != 'wait_for_confirm') die('error on verify');
        $reference = $_REQUEST['reference'];
        $token = file_get_contents("state/$reference-token-volume.txt"); 
        if(!$token) exit;
        
        $input = explode('#',base64_decode($token));
        $server_id = intval($input[0]);
        $inbound_id = intval($input[1]);
        $remark = htmlspecialchars(strip_tags($input[2]));
        $planid = intval($input[3]);
        $userid = intval($input[4]); 
        $res = $telegram->db->query("select * from extra_plan where id=$planid")->fetch(2);  
        $price = $res['price'];
         $seller = $telegram->db->query("select * from fl_sellers where userid=$userid")->fetch(2);
				if(!empty($seller)) $price = $price - (($price) * ($seller['percent'] / 100));
        $volume = $res['volume'];

        $pay_result = bahamta_verify($price, $reference, $TokenCode);
        if($pay_result == 'success'){
           unlink("state/$reference-token-volume.txt");
    
            require_once('vray.php');
            if($inbound_id > 0)
                $response = update_client_traffic($server_id, $inbound_id, $remark, $volume, 0);
            else
                $response = update_inbound_traffic($server_id, $remark, $volume, 0);
            if($response->success){
                $telegram->db->query("update fl_order set notif=0 where remark='$remark'");
                $telegram->db->query("INSERT INTO `fl_extra_order` VALUES (NULL, '$userid', '$server_id', '$inbound_id', '$remark', '$price', '$time');");
                $telegram->sendMessage($userid, "✅$volume گیگ به حجم سرویس شما اضافه شد");
                 echo 'تراکنش با موفقیت انجام شد';
                $msg = "✅ سفارش شما با موفقیت ثبت شد";
                $telegram->sendMessage($userid, $msg);
                $sndmsg = "
خرید $volume گیگ با درگاه باهمتا
قیمت : $price
آیدی کاربر : $userid
آیدی سرور : $server_id
ریمارک : $remark
";
    $telegram->sendMessage($sendchnl,$sndmsg);
            }else {
                die("مشکل فنی در ارتباط با سرور. لطفا به مدیریت اطلاع بدید");
            }
        }
        
        
    }
}

if($type == 'wallet'){
    if($action == 'pay'){
        $amount = intval($_GET['amount']);// echo $amount;die;
        //if($amount < $min_wallet_charge) die('مبلغ کمتر از 2هزار تومان است');
        $userid = intval($_GET['userid']);
        $result = $telegram->db->query("select * from fl_user WHERE userid='$userid'")->rowCount();
        if($result == 0) die('اطلاعات ارسال اشتباه است');
        $rcount = $telegram->db->query("select * from fl_wallet where date +180 > $time and userid='$userid'")->rowCount();
        if($rcount > 0) exit;
        
        $token = substr(sha1(rand(0,9999999).uniqid().microtime()), 0, 15);
        $telegram->db->query("INSERT INTO `fl_wallet` VALUES (NULL, '$token',$amount, $userid, '','0', $time);");
        $woid = $telegram->db->lastInsertId(); 
        bahamta_payment($amount, $TokenCode, $token, $callback_url); 
    }elseif($action == 'verify'){
        if (!isset($_GET['state']) && $_GET['state'] != 'wait_for_confirm') die('error on verify');
        $token = str_replace([' ','/',"'",'"'],'', $_GET['reference']);
        if(!$token) exit;

        $rcount = $telegram->db->query("select * from fl_wallet where date +20 > $time and userid='$userid'")->rowCount();
        if($rcount > 0) exit;
        
        $res = $telegram->db->query("select * from fl_wallet where token='$token' and status=0")->fetch(2);
        if(empty($res)) exit;
        $amount = $res['amount'];
        $userid = $res['userid'];
        $pay_result = bahamta_verify($amount, $token, $TokenCode);
        if($pay_result == 'success'){
            $res = $telegram->db->query("select * from fl_wallet where token='$token' and status=0")->fetch(2);
            if(empty($res)) exit;
        
            echo '<h1 style="text-align:right;color:green;">کیف پول شما با موفقیت شارژ شد</h1>' ; 
            $telegram->db->query("update fl_user set wallet= wallet + $amount where userid='$userid'");
            $telegram->db->query("update fl_wallet set status=1,date= $time - 60 where token='$token'");
            $msg = "✅ کیف پول شما به مبلغ $amount تومان شارژ شد ";
            $telegram->sendMessage($userid, $msg);
            $sndmsg = "
افزایش موجودی با درگاه باهمتا
مقدار : $amount تومان
آیدی کاربر : $userid
";
    $telegram->sendMessage($sendchnl,$sndmsg);
            echo $msg;
        }
        
        
    }
}

if($type == 'buy'){
    if($action == 'pay'){
        if(!isset($_GET['token'])){
            header('location:https://t.me/'.botid);
            exit;
        }
        
        $token = base64_decode($_GET['token']); 
        $token = explode('.',$token);
        $userid = intval($token[0]);
        $fid = intval($token[1]);
        if($token[2]) $dcode = htmlspecialchars(strip_tags($token[2]));
        
        $file_detail = $telegram->db->query("select * from fl_file WHERE id=$fid")->fetch(2); 
        $date = time();
        $days = $file_detail['days'];
        $expire_date = $date + (86400 * $days);
        $protocol = $file_detail['protocol'];
        $price = $file_detail['price'];
         $seller = $telegram->db->query("select * from fl_sellers where userid=$userid")->fetch(2);
				if(!empty($seller)) $price = $price - (($price) * ($seller['percent'] / 100));
        $server_id = $file_detail['server_id'];
        $acount = $file_detail['acount'];
        $inbound_id = $file_detail['inbound_id'];
        
        if($dcode){
            $dcount = $telegram->db->query("select * from fl_discount WHERE code='$dcode' and active=1");
            if($dcount->rowCount() > 0){
                $amount = $dcount->fetch(2)['amount'];
                if($amount <= 100) {
                    $price = $price * (100-$amount)/100;
                }else {
                    $price = $price - $amount ;
                }
            }
        }
            
        if($acount == 0 and $inbound_id != 0){
            echo 'ظرفیت این کانکشن پر شده است';
            exit;
        }
        
        $order = $telegram->db->query("INSERT INTO `fl_order` VALUES (NULL,  {$userid}, '', {$fid}, $server_id, $inbound_id, '', '$protocol', $expire_date, '', $price,0, '$date', 0);");
        $order_id = $telegram->db->lastInsertId();
        bahamta_payment($price, $TokenCode, $order_id, $callback_url);
    }elseif($action == 'verify'){
        if (!isset($_REQUEST['state']) && $_REQUEST['state'] != 'wait_for_confirm') die('error on verify');
        $order_id = $_REQUEST['reference'];
        if(!$order_id) exit;
        
        $orderDetails = $telegram->db->query("select * from fl_order where id={$order_id} and status=0")->fetch(2);
        if(empty($orderDetails)) die('این سفارش قبلا تایید شده است');
        $userid = $orderDetails['userid'];
        $fid = $orderDetails['fileid'];
        $file_detail = $telegram->db->query("select * from fl_file WHERE id=$fid")->fetch(2);
        $days = $file_detail['days'];
        $date = time();
        $expire_microdate = intval(floor(microtime(true) * 1000) + (864000 * $days * 100));
        $expire_date = $date + (86400 * $days);
        $type = $file_detail['type'];
        $volume = $file_detail['volume'];
        $protocol = $file_detail['protocol'];
        $price = $file_detail['price'];
         $seller = $telegram->db->query("select * from fl_sellers where userid=$userid")->fetch(2);
				if(!empty($seller)) $price = $price - (($price) * ($seller['percent'] / 100));
        $server_id = $file_detail['server_id'];
        $netType = $file_detail['type'];
        $acount = $file_detail['acount'];
        $inbound_id = $file_detail['inbound_id'];
        $limitip = $file_detail['limitip'];
        
        $price = $orderDetails['amount'];
        
        $pay_result = bahamta_verify($price, $order_id, $TokenCode);
        if($pay_result == 'success'){
            
    
            // V2ray Api
            require_once('vray.php');
            $uniqid = generateRandomString(42,$protocol); 
        
            $savedinfo = file_get_contents('savedinfo.txt');
            $savedinfo = explode('-',$savedinfo);
            $port = $savedinfo[0] + 1;
            $last_num = $savedinfo[1] + 1;
        
            $srv_remark = $telegram->db->query("select * from fl_server WHERE id=$server_id")->fetch(2)['remark'];
			$uremark = $telegram->db->query("select * from fl_remark where userid='$userid'")->fetch(2);
			if($uremark) $uremark = $uremark['remark']; else $uremark = $srv_remark;
			$remark = "{$uremark}-{$last_num}";
        
            file_put_contents('savedinfo.txt',$port.'-'.$last_num);
            //$telegram->sendMessage($cuserid,"$server_id, $uniqid, $inbound_id, $expire_microdate, $remark, $volume");exit;
            
            if($inbound_id == 0){    
                $response = add_inbound($server_id, $uniqid, $protocol, $port, $expire_microdate, $remark, $volume, $netType); 
                if(! $response->success){
                    // run again
                    $response = add_inbound($server_id, $uniqid, $protocol, $port, $expire_microdate, $remark, $volume, $netType);
                } 
            }else {
                $response = add_inbount_client($server_id, $uniqid, $inbound_id, $expire_microdate, $remark, $volume, $limitip); 
                if(! $response->success){
                    // run again
                    $response = add_inbount_client($server_id, $uniqid, $inbound_id, $expire_microdate, $remark, $volume, $limitip);
                } 
            }
            
            //$telegram->sendMessage($cuserid,json_encode($response));exit;
             
            $vray_link = genLink($server_id, $uniqid, $protocol, $remark, $port, $netType, $inbound_id);
            
            $acc_text = "🔗 $remark \n <code>$vray_link</code>" . " \n  برای کپی کردن لینک روی آن کلیک کنید \n";
            
            
            include 'phpqrcode/qrlib.php';
            $path = 'images/';
            $file = $path.$userid.".png"; //unlink($file);
            $ecc = 'L';
            $pixel_Size = 10;
            $frame_Size = 10;
            QRcode::png($vray_link, $file, $ecc, $pixel_Size, $frame_size);
        	addBorderImage($file);
            //$fileLink = "<a href='".baseURI.$file."'>&#8194;</a>";
        	//$telegram->sendHTML($cuserid,$acc_text.$fileLink,$finalop);
        	$telegram->sendPhoto($userid,$acc_text,$file);
        
        	$order = $telegram->db->query("update `fl_order` set link='$vray_link',remark='$remark',status=1 where id=$order_id");
        	
        	if($inbound_id == 0) {
                $server_info = $telegram->db->query("SELECT * FROM fl_server WHERE id=$server_id")->fetch(2);
                if($server_info['ucount'] != 0)
                    $telegram->db->query("UPDATE `fl_server` SET `ucount` = ucount - 1 WHERE id=$server_id");
            }else{
                if($acount != 0) 
                    $telegram->db->query("UPDATE `fl_file` SET `acount` = acount - 1 WHERE id=$fid");
            }
            
            $msg = "✅سفارش شما با موفقیت ثبت شد";
            echo $msg;
            $telegram->db->query("update fl_order set status=1 where id='$order_id'");
            $telegram->sendMessage($userid, $msg);
            $sndmsg = "
خرید درگاه باهمتا 
قیمت : $price
آیدی کاربر : $userid
آیدی سرور : $server_id
لینک دریافتی :

$vray_link
";
    $telegram->sendMessage($sendchnl,$sndmsg);
            // pay referer
            $userReferer = $telegram->db->query("select * from fl_subuser where userid=$userid");
            if($userReferer->rowCount() ){
				$ures = $userReferer->fetch(2);
				$userToplevel = $ures['toplevel_userid'];
				$ufname = $ures['fname'];
				$amount = $pursant > 100 ? $pursant : ($price) * ($pursant / 100);
				$telegram->db->query("update fl_user set wallet= wallet + $amount WHERE userid=$userToplevel");
				if($pursant > 100) $msg = "💟کاربر {$ufname} یک خرید به مبلغ  $price تومان انجام داد و $amount تومان به عنوان هدیه به کیف پول شما اضافه شد👍";
				else $msg = "💟کاربر {$ufname} یک خرید به مبلغ  $price تومان انجام داد و $pursant درصد آن یعنی $amount تومان به کیف پول شما اضافه شد👍";
				$telegram->sendMessage($userToplevel, $msg); 
			}

            
        }
    } // verify
}



function bahamta_payment($price, $TokenCode, $oid, $callback_url){
    $amount_irr = $price *10;
    $api_key = $TokenCode;
    $url = "https://webpay.bahamta.com/api/create_request?";
    
    // Complete url parameters
    $url .= http_build_query(array(
        'api_key' => $api_key,
        'reference' => $oid,
        'amount_irr' => $amount_irr,
        'callback_url' => $callback_url,
    ));

    // Create curl request
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    $result = curl_exec($ch);
    curl_close($ch);

    $result = json_decode($result);

    // If everything is okay !
    if ($result->ok == true) {
        header("Location: " . $result->result->payment_url);
        exit;
    } else {
        die(bahamta__error($result->error));
    }
}

function bahamta_verify($price, $reference, $TokenCode){ 
    $url = 'https://webpay.bahamta.com/api/confirm_payment?';
    // Add parameters
    $url .= http_build_query(array(
        'api_key' => $TokenCode,
        'reference' => $reference,
        'amount_irr' => $price *10
    ));

    // Curl request
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    $result = curl_exec($ch);
    $result = json_decode($result);
    curl_close($ch);
    // success
    if ($result->ok == true) {
        return "success";
    } else {
        echo bahamta__error($result->error);die;
    }

}
function bahamta__error($code)
{

    $error = '';

    // Error Message
    switch ($code) {
        case "INVALID_API_CALL":
            $error = 'ساختار درخواست ارسالی به درگاه وب پی اشتباه است!';
            break;
        case "INVALID_API_KEY":
            $error = 'کلید ارائه شده معتبر نمی باشد';
            break;
        case "NOT_AUTHORIZED":
            $error = 'هیچ فروشنده ای برای کلید ارائه شده تعیین نشده است';
            break;
        case "INVALID_AMOUNT":
            $error = 'مبلغ ارسال شده نادرست است';
            break;
        case "INVALID_REFERENCE":
            $error = 'شماره شناسه پرداخت ناردست است';
            break;
        case "INVALID_PARAM":
            $error = 'خطای ناشناخته ای در وب پی رخ داده است';
            break;
        case "UNKNOWN_BILL":
            $error = 'پرداختی با شماره شناسه فرستاده شده ثبت نشده است';
            break;
        case "MISMATCHED_DATA":
            $error = 'مبلغ اعلام شده با آنچه در webpay ثبت شده است مطابقت ندارد.';
            break;
        case "NOT_CONFIRMED":
            $error = 'این پرداخت تأیید نشد.';
            break;
        case "SERVICE_ERROR":
            $error = 'خطای داخلی سرویس رخ داده است.';
            break;
        default:
            $error = 'خطایی ناشناخته'. $code;
    }

    return $error;
}
